;-------------------------------------------------------------------------
; Copyright (c) 1999 Steven Freyder, David Helland, and Bruce D. Lightner.
; Use subject to licensing restrictions described in "PICOWEB SERVER
; SOFTWARE LICENSE AGREEMENT DATED JULY 14, 1999" (See file LICENSE.txt).
;-------------------------------------------------------------------------

.eseg
.org 0x8000+CGI_INDEX_BASE

;
; top two bits set in length indicate CGI.  actually the length is not
; really used except for the flags.  up to the CGI code to return on its
; own!
;-
#define CGI(X) .dw X,(X##_end-X)|(0x8000+0x4000)    ; flags as CGI
#define CGI_BEGIN(X) X##:
#define CGI_END(X) X##_end:
#define putchar_serial .dw pmovbi,putc_b,0
#define putchar_net    .dw pmovbi,putc_b,1
#define serial_binary  .dw pser_mode,1
#define serial_normal  .dw pser_mode,0
#define showword(x)    .dw pprintv|XX,0,WORD(x)
#define BAUD           (UBRR+0x20)  /* mem addr of baud rate divisor */
#define B2400           207
#define B4800           103
#define B9600           51
#define B19200          25
#define SERTEST_BAUD    B9600
#define SER_TMO         800

cgi_table:
    .dw (cgi_table_end-cgi_table)/4
    CGI(cgi00)				; iu00
    CGI(cgi01)				; iu01
    CGI(sertest)			; iu02
    CGI(time_from_server)	; iu03
    CGI(answerman_all)      ; iu04
    CGI(temp_top)           ; iu05
    CGI(temp_bottom)        ; iu06
    CGI(set_point)          ; iu07
    CGI(setpoint_finger)    ; iu08
cgi_table_end:

;+
; **-cgi00-testor.
;-

CGI_BEGIN(
    cgi00
)
    .dw pmovbi,BAUD,B19200              ; 19.2KB
    serial_normal                       ; temporary kludge
    .dw pprint,ehtml_header
    .dw pprint,ereset_msg   ;;eestring ereset_msg "Serial reset.\n"
    .dw pret
CGI_END(cgi00)
;+
; **-temperature-show the temperature in decimal.
;-
CGI_BEGIN(
    cgi01
)
    .dw pcall,tempf_buf
    .dw pcall,update_heater
    .dw pjump,decconv                   ; convert to decimal ascii
CGI_END(cgi01)
;+
; **-sertest-serial I/O testor.
;-

CGI_BEGIN(
    sertest
)
    .dw pmovbi,BAUD,SERTEST_BAUD
    .dw pprint,ehtml_header
;;eestring ehtml_header "HTTP/1.0 200\nContent-type: text/html\n\n"
    putchar_serial                      ; switch putchar to serial port
    .dw pmovwi|XX,buf,WORD(data_addr)   ; get data address
    .dw paddwi,buf,10                   ; GET /iu02?X
    .dw pmovwi|XX,buf+2,WORD(data_len)
sertest_next:
    .dw pr2s|XX,buf+4,WORD(buf),1       ; get next byte
    .dw pandwi,buf+4,0xff
    .dw pcmpwi,buf+4,'.'
    .dw pjumpeq,serial_done
    .dw pputcb,buf+4
    .dw paddwi,buf,1                    ; bump data address
    .dw psubwi,buf+2,1
    .dw pjumplo,serial_done
    .dw pjumpne,sertest_next
serial_done:
    .dw pmovbi,buf,0x0d
    ;
    ; come here with request char in buf.
    ;
serial_request:
    .dw pmovwi,buf+4,SER_TMO            ; select the timeout period
    .dw pmovbi,com_lost,0               ; zero out lost char counter
    serial_normal
    serial_binary                       ; put serial port in binary mode
    putchar_serial                      ; switch putchar to serial port
    .dw pputcb,buf                      ; output to serial port
    putchar_net                         ; switch putchar back to 'net
;
; loop reading chars from the serial buffer and writing to 'net until
; there are no more characters.
;
    .dw pmovwi|XX,buf+2,WORD(buf+4)     ; timeout
    .dw pcall,fsertest
#if 0
    .dw pprint,edone_msg                ;;eestring edone_msg "\nLost="
    .dw phexbi|XX,BYTE(com_lost)
#endif
    .dw pret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.cseg

fsertest:
;
; buf+4 (word) = timeout loop count, and buf+2 is already loaded with
; that timeout value.
;
sertest_nextchar:
    .dw pser_getc,buf                   ; get a char into buf
    .dw pjumpeq,sertest_empty           ; no more chars!
    .dw pputcb,buf                      ; put char to the net
    .dw pmovwi|XX,buf+2,WORD(buf+4)     ; timeout
    .dw pjump,sertest_nextchar          ; go get another one
sertest_empty:
    .dw psubwi,buf+2,1                  ; decrement timeout
    .dw pjumpne,sertest_nextchar        ; not yet timed out
    .dw pret

.eseg
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

CGI_END(sertest)

CGI_BEGIN(
    time_from_server
)
    .dw pmovbi,buf,'T'                  ; time request
    .dw pjump,serial_request            ; get time from server
CGI_END(time_from_server)

.dseg
#define ANSWERMAN_BAUD B9600            ; temporary for testing
#define ANSLEN  40
ansptr: .byte   2
ansbuf: .byte   ANSLEN
#define ansp    buf
.eseg

CGI_BEGIN(
    answerman_all
)
    .dw pmovbi,BAUD,ANSWERMAN_BAUD
    .dw pmovwi,ansptr,ansbuf            ; point to start of buffer
    .dw pmovwi,buf+4,SER_TMO
    .dw pmovwi,buf+2,WORD(buf+4)
    .dw pmovbi,com_lost,0               ; zero out lost char counter
    ;
    ; going from normal to binary mode flushes the buffer.
    ;
    serial_normal
    serial_binary                       ; put serial port in binary mode
    ;
    ; switch to serial port so we can slam out the request.
    ;
    putchar_serial
    ;
    ; the leading \r appears to be necessary when the baud rate has just
    ; changed (like first thing after reboot when the baud rate is at 19.2
    ; and ANSWERMAN_BAUD is 9600).
    ;
    .dw pprint,answerman_query  ;;eestring answerman_query "\r! MAN0 QE\r"
    ;
    ; now back to the 'net so we can output the bytes.
    ;
    putchar_net
;
; loop reading chars from the serial buffer and writing to 'net until
; there are no more characters.
;
    .dw pcall,ans_in

    .dw pmovwi,ansp,ansbuf
ansp_next:
    .dw pcmpwi|XX,ansp,WORD(ansptr)
    .dw pjumpeq,ans_show_done
    .dw pputcb|XX,WORD(ansp)
    .dw paddwi,ansp,1
    .dw pjump,ansp_next
ans_show_done:
    .dw pret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.cseg

ans_in:
;
; buf+4 (word) = timeout loop count, and buf+2 is already loaded with
; that timeout value.
;
ans_nextchar:
    .dw pser_getc,buf                   ; get a char into buf
    .dw pjumpeq,ans_empty               ; no more chars!
    .dw pcmpbi,buf,0x0a
    .dw pjumpeq,ans_done
    .dw pmovbi|XX,WORD(ansptr),BYTE(buf)    ; save next byte
    .dw paddwi,ansptr,1                 ; advance pointer
    .dw pcmpwi,ansptr,ansbuf+ANSLEN     ; check if reached limit
    .dw pjumpeq,ans_done                ; sorry - ran out of space
    .dw pmovwi|XX,buf+2,WORD(buf+4)     ; timeout
    .dw pjump,ans_nextchar              ; go get another one
ans_empty:
    .dw psubwi,buf+2,1                  ; decrement timeout
    .dw pjumpne,ans_nextchar            ; not yet timed out
ans_done:
    .dw pret

.eseg

CGI_END(answerman_all)
;+
; **-decconv-decimal converter.
;
; inputs:
;   buf = word to convert
;
; outputs:
;   result printed (with pputc)
;
; caveats:
;   MUST be called with pcall!!
;-
#define DIG_BUF buf+6
#define DIG_PTR buf+4
#define DEC_REM buf+2
#define DEC_VAL buf

decconv:    .dw pmovwi,DIG_PTR,DIG_BUF         ; pcode_routine
    .dw pbitwi,DEC_VAL,0x8000           ; check the sign
    .dw pjumpeq,decconv1                ; positive - start conversion
    .dw pnegw,DEC_VAL                   ; negate it
    .dw pputc,'-'
decconv1:
    .dw pdiv|XX,DEC_VAL,WORD(DEC_VAL),10    ; get next one
    .dw paddwi,DEC_REM,'0'              ; convert digit for display
    .dw pmovbi|XX,WORD(DIG_PTR),BYTE(DEC_REM)  ; save digit
    .dw paddwi,DIG_PTR,1                ; bump past digit just stored
    .dw psubwi,DEC_VAL,0                ; test remaining value
    .dw pjumpne,decconv1                 ; if more to convert
decconv2:
    .dw psubwi,DIG_PTR,1                ; point to next one
    .dw pputcb|XX,BYTE(DIG_PTR)         ; show it
    .dw pcmpwi,DIG_PTR,DIG_BUF          ; check if just did last one
    .dw pjumpne,decconv2                 ; nope - do next one
    .dw pret
CGI_BEGIN(
    temp_top
)
    .dw pcall,tempf_buf
    .dw pcall,compute_top
    .dw pjump,decconv
CGI_END(temp_top)
compute_top:
    .dw pmovwi,buf+2,130
    .dw psubwi|XX,buf+2,WORD(buf)
    .dw pshnw,buf+2,1
    .dw pmovwi|XX,buf,WORD(buf+2)
    .dw pret
CGI_BEGIN(
    temp_bottom
)
    .dw pcall,tempf_buf
    .dw pshnw,buf,1
    .dw pjump,decconv
CGI_END(temp_bottom)

CGI_BEGIN(
    set_point
)
    .dw pr2s|XX,buf,WORD(data_addr),16
    .dw pcmpbi,buf+9,'?'            ; GET /iiNN?s=xx        ; we want xx
                                    ; 01234567890123
    .dw pjumpne,not_setting_setpoint
    .dw pclrw,buf
    .dw pclrw,buf+2
    .dw pmovbi|XX,buf,BYTE(buf+12)
    .dw psubwi,buf,'0'
    .dw pmul|XX,buf,WORD(buf),10    ; do first digit
    .dw pmovbi|XX,buf+2,WORD(buf+13)
    .dw psubwi,buf+2,'0'
    .dw paddwi|XX,buf,WORD(buf+2)
    .dw peeprom_write|XX,1,BYTE(buf)
not_setting_setpoint:
    .dw pcall,get_setpoint
    .dw pjump,decconv
CGI_END(set_point)
get_setpoint:
    .dw pcall,update_heater
    .dw pclrw,buf
    .dw ee2s,buf,1,1
    .dw pret
#define CUR_TEMP buf
#define CUR_SETP buf+14
update_heater:
#if defined(ENABLE_HEATER)
    .dw pclrw,CUR_SETP
    .dw ee2s,CUR_SETP,1,1           ; get setpoint
    .dw pcall,tempf_buf             ; get temperature (into buf)
    .dw pcmpwi|XX,CUR_TEMP,WORD(CUR_SETP)  ; check temp against setpoint
    .dw pjumplo,heater_on
    .dw pmovbi,PORTD+0x20,1<<LED_BIT
#endif
    .dw pret
heater_on:
    .dw pmovbi,PORTD+0x20,0
    .dw pret
tempf_buf:
    .dw pclrw,buf
#if defined(TEMPERATURE_EEPROM)
    .dw ee2s,buf,TEMPERATURE_EEPROM,1   ; read temperature (C) to buf
#else
    .dw pread_temp,buf                  ; get temp
#endif
    .dw pmovwi,buf+4,0x80              ; set up for sign test
    .dw pandwi|XX,buf+4,WORD(buf)       ; check the sign
    .dw pjumpeq,temp_positive            ; it is positive
    .dw pmovbi,buf+1,0xff              ; extend the sign
    .dw pnegw,buf                       ; negate
temp_positive:
    .dw pmul|XX,buf,WORD(buf),9         ; C*9
    .dw pdiv|XX,buf,WORD(buf),5         ; /5
    .dw pandwi,buf+4,0x80               ; test original sign
    .dw pjumpeq,temp_norenegate          ; positive
    .dw pnegw,buf
temp_norenegate:
    .dw paddwi,buf,32                   ; +32 - buf now has temp (F)
    .dw pret
CGI_BEGIN(
    setpoint_finger
)
    .dw pcall,get_setpoint
    .dw pcall,compute_top
    .dw psubwi,buf,3
    .dw pjump,decconv
CGI_END(setpoint_finger)
